diff --git a/src/backend/access/heap/heapam_handler.c b/src/backend/access/heap/heapam_handler.c
index 7a9a640989..e171b87a2a 100644
--- a/src/backend/access/heap/heapam_handler.c
+++ b/src/backend/access/heap/heapam_handler.c
@@ -1039,17 +1039,12 @@ heapam_scan_analyze_next_tuple(TableScanDesc scan, TransactionId OldestXmin,
 		itemid = PageGetItemId(targpage, hscan->rs_cindex);
 
 		/*
-		 * We ignore unused and redirect line pointers.  DEAD line pointers
-		 * should be counted as dead, because we need vacuum to run to get rid
-		 * of them.  Note that this rule agrees with the way that
-		 * heap_page_prune() counts things.
+		 * We ignore unused and redirect line pointers.  We don't count LP_DEAD
+		 * line pointers as deadrows.  Note that this rule agrees with the way
+		 * that lazy_scan_prune() counts things.
 		 */
 		if (!ItemIdIsNormal(itemid))
-		{
-			if (ItemIdIsDead(itemid))
-				*deadrows += 1;
 			continue;
-		}
 
 		ItemPointerSet(&targtuple->t_self, hscan->rs_cblock, hscan->rs_cindex);
 
